/*
    Title:    AVR-GCC test program #1 for the STK200 eva board
    Author:   Danny H. Newport
    Date:     8/2004
    Purpose:  check for motion and start vcr to record
    needed
    Software: AVR-GCC
    needed
    Hardware: ATS90S2313
    Note:     To contact me, mail to
                  dannynewp@aol.com
              You might find more AVR related stuff at my homepage:
                  http://www.danny-newport.com

*/

#include <io.h>

#define STOP    0
#define RECORD  1
#define PAUSE   2
#define POWER   3
#define S1LSD   PINB0   //tx circuit setting
#define S1MSD   PINB1   //tx circuit setting
#define SEND    PINB2   //tx circuit transmit(send)
#define VidOK   PINB3   //rx circuit Video present at low pin
#define MOTION  PINB4   //rx circuit Video motion detected at high pin
#define S2LSD   PINB5   //rx circuit motion sensitivity
#define S2LSD   PINB6   //rx circuit motion sensitivity
#define ENABLE  PINB7   //rx circuit enable at high pin
//defines for delay
#define CPU_freq    10000000						//cpu clock frequency
#define CYCLES_PER_US ((CPU_freq+500000)/1000000) 	// cpu cycles per microsecond
#undef ECHO
#define UART_BAUD_RATE 9600
#define UART_BAUD_SELECT ((CPU_freq/(UART_BAUD_RATE*16))-1)

/* global variables for delay functions */
uint16_t delay_count=CPU_freq/4000;				// used in delay function

//prototypes
void SetVCR(int lst);

typedef unsigned char  u08;


// millisecond delay function
void delay_ms(uint8_t ms)
{
	uint16_t cnt; asm volatile (

		"\n" "L_dl1%=:" "\n\t" "mov %A0, %A2" "\n\t" "mov %B0, %B2" "\n" "L_dl2%=:" "\n\t"

		"sbiw %A0, 1" "\n\t" "brne L_dl2%=" "\n\t" "dec %1" "\n\t" "brne L_dl1%=" "\n\t" : "=&w" (cnt) : "r" (ms), "r" (delay_count) );
}
int main( void )
{
   int loop=0;
   outp(0xe7,DDRB);            /* use all pins on PortB for input */
   outp(0xff,DDRD);            /* use all pins on PortB for output */
   sbi(PORTB,PINB5);       //SET TO MOST SENSITIVE
   sbi(PORTB,PINB6);       //SET TO MOST SENSITIVE
   sbi(PORTB,PINB7);       //SET TO ENABLE VIDEO
   sbi(PORTB,PINB2);       //turn off ir transmit
   delay_ms(10);

        sbi(PORTD,PIND3);
       for(loop=0;loop<50;loop++)
          delay_ms(10);
        cbi(PORTD,PIND3);
       for(loop=0;loop<50;loop++)
          delay_ms(10);


   //loop forever
   for (;;) {
     
      if(bit_is_clear(PINB,PINB4)==0)
      {
        SetVCR(RECORD);
        sbi(PORTD,PIND3);
       for(loop=0;loop<100;loop++)
        {
          if(bit_is_clear(PINB,PINB4)==0)
                loop=0;
          delay_ms(100);
        }


        SetVCR(STOP);

       
   
      }
else
                cbi(PORTD,PIND3);


   }
}
void SetVCR(int lst)
{
        int loop=0;


        switch(lst)
        {
        case 0: //stop
                cbi(PORTB,PINB0);
                cbi(PORTB,PINB1);
        break;
        case 1: //Record
                sbi(PORTB,PINB0);
                cbi(PORTB,PINB1);
        break;
        case 2: //Pause
                cbi(PORTB,PINB0);
                sbi(PORTB,PINB1);
        break;
        case 3: //power
                sbi(PORTB,PINB0);
                sbi(PORTB,PINB1);
        break;
        default:
        break;
        }

       for(loop=0;loop<10;loop++)
          delay_ms(10);
       cbi(PORTB,PINB2);
       for(loop=0;loop<10;loop++)
          delay_ms(10);
       sbi(PORTB,PINB2);
     
       for(loop=0;loop<10;loop++)
          delay_ms(10);

}

